
# ------------------------------------------------------------
# Simulation d'une loi binomiale : partie algorithmique
# ------------------------------------------------------------

# etape 1
calculer_nbPiles = function(n, p) { 
	nbPiles=0 
	for (k in seq(1, n)) {
		if (runif(1)<=p) { 
			nbPiles=nbPiles+1 
		} 
	}
	return(nbPiles)
}

# etape 2
calculer_estimations = function(n, p, nbSimus) { 
  estimations = numeric(0)
  for (k in seq(0, n)) {
    estimations[k+1]=0 
  }
  for (j in seq(1, nbSimus)) {
    k=calculer_nbPiles(n, p) 
    estimations[k+1]=estimations[k+1] + 1/nbSimus 
  }
  return(estimations)
}

# 10000 simulations d'une loi de parametres 30 et 0.7
calculer_estimations(30,0.7,10000)



# ------------------------------------------------------------
# Simulation d'une loi binomiale : prolongements
# ------------------------------------------------------------

# diagramme en batons de la loi binomiale
n=30
p=0.7
nbSimus=10000
estim1 = calculer_estimations(n,p,nbSimus)
plot(estim1, type="h", xlab="", ylab="")

# comparaison loi binomiale centree-reduite et loi normale centree-reduite
	# diagramme en batons de la loi binomiale centree-reduite
sigma = sqrt(n*p*(1-p))
mu = n*p
centre_reduit = (seq(0,n)-mu)/sigma
plot(centre_reduit, estim1, type="h", xlab="", ylab="", ylim=c(0,dnorm(0)))
	# ajout sur le graphique de la loi normale centree-reduite
lines(centre_reduit, dnorm(centre_reduit))

# comparaison loi binomiale centree-reduite et loi normale centree-reduite
	# la loi normale
plot(centre_reduit, dnorm(centre_reduit), type="l", xlab="", ylab="", col="red")
	# la fonction en escalier (en bleu) et l'histogramme (en pointillés)
x = centre_reduit -0.5/sigma
y = sigma*estim1
for (k in seq(1, n)) {
  lines( c(x[k],x[k]) , c(0, y[k]), lty="dotted" )
  lines( c(x[k],x[k+1]), c(y[k], y[k]), col="blue" )
  lines( c(x[k+1],x[k+1]) , c(0, y[k]), lty="dotted" )
}


